<template>
  <div>
      <v-toolbar small dense class="mt-2 mb-2 elevation-0"  dark color="transparent">
         <v-btn ripple small dark class="elevation-1" color="primary" @click="addNote">
            <v-icon>add</v-icon>
            <span>{{$i18n.t("note.actions.add.text")}}</span>
         </v-btn>
         <v-spacer/>
         <span style="opacity: .5">{{count}}</span>
      </v-toolbar>
      
      <v-timeline class="hidden-xs-only" dark v-if="notes.length > 0">
        <v-timeline-item light
          v-for="(note, index) in notes"
          :key="note.id"
          small fill-dot
          color="secondary">
          <span style="font-weight: 600; color: rgba(255, 255, 255, .8)" slot="opposite">{{formatDate(note.created)}}</span>
          <NoteCard :note="note" :application="application" @delete="deleteNote(note, index)"/>
        </v-timeline-item>
      </v-timeline>
      
      <v-layout row class="hidden-sm-and-up" v-if="notes.length > 0">
        <v-flex xs12>
          <NoteCard :note="note" class="mb-2" 
                    v-for="(note, index) in notes"
                    :key="note.id" 
                    :application="application" 
                    @delete="deleteNote(note, index)"/>
        </v-flex>
      </v-layout>
      
      <v-layout row v-if="notes.length == 0">
        <v-flex xs12 class="text-xs-center mt-5 headline" style="color: rgba(255, 255, 255, .8); text-weight: thin">
           {{$i18n.t("note.actions.add.description")}}   
        </v-flex>
      </v-layout>
       
  </div>
  
</template>

<script>
import moment from 'moment'
import NoteCard from './NoteCard'
export default {
    name: 'NoteListView',
    props: ['application'],
    components: { NoteCard },
    data() {
        return {
            numberOfColumns: 2,
            root: this.application,
            notes: this.application.notes.sort((a, b) => moment(b.created).valueOf() - moment(a.created || new Date()).valueOf())
        }
    },
    computed: {
        count() {
            return this.$i18n.tc("application.note", this.root.notes.length)
        }
    },
    methods: {
        async deleteNote(note,index) {
            try {
                this.root.notes.splice(index, 1);
                await this.$api.deleteNote(this.application.id, note);
            }
            catch (e) {
                this.root.notes.splice(index, 0, note)
                this.$logger.error("error deleting note", e.message)
                this.error('Could not delete note')
            } 
        },
        async addNote() {
            try {
                let note = {  }
                this.application.notes.splice(0, 0, note)
                const saved = await this.$api.createNote(this.root.id);
                this.application.notes.splice(0, 1, saved)
            }
            catch (e) {
                this.root.notes.splice(this.root.notes.length - 1, 1)
                this.error(e, 'Could not create note')
            }   
        },
        error(e, message) {
            this.$logger.error("error adding note", e.message)
            this.$emit('error', {
                message,
                color: 'error'
            })
        },
        formatDate(d) {
            return moment(d).format(this.$i18n.t("note.dateFormat"))
        }
    },
    mounted() {
    
    }
}
</script>